package com.zipcodewilmington;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.HashMap;

/**
 * Created by leon on 1/29/18.
 */
public class StringArrayUtils {
    /**
     * @param array array of String objects
     * @return first element of specified array
     */ // TODO
    public static String getFirstElement(String[] array) {
        return array[0];
    }

    /**
     * @param array array of String objects
     * @return second element in specified array
     */
    public static String getSecondElement(String[] array) {
        return array[1];
    }

    /**
     * @param array array of String objects
     * @return last element in specified array
     */ // TODO
    public static String getLastElement(String[] array) {
        return array[array.length - 1];
    }

    /**
     * @param array array of String objects
     * @return second to last element in specified array
     */ // TODO
    public static String getSecondToLastElement(String[] array) {
        return array[array.length - 2];
    }

    /**
     * @param array array of String objects
     * @param value value to check array for
     * @return true if the array contains the specified `value`
     */ // TODO
    public static boolean contains(String[] array, String value) {
        boolean results = false;
        for(String word : array) {
            if(word.equals(value)) {
                results = true;
            }
        }
        return results;
    }

    /**
     * @param array of String objects
     * @return an array with identical contents in reverse order
     */ // TODO
    public static String[] reverse(String[] array) {
        String[] reversedArray = new String[array.length];
        for(int i = array.length - 1, j = 0; i >= 0; i--, j++) {
            reversedArray[j] = array[i];
        }
        return reversedArray;
    }

    /**
     * @param array array of String objects
     * @return true if the order of the array is the same backwards and forwards
     */ // TODO
    public static boolean isPalindromic(String[] array) {
        String[] reversedArray = reverse(array);
        if(Arrays.equals(reversedArray, array)) {
            return true;
        }
        return false;
    }

    /**
     * @param array array of String objects
     * @return true if each letter in the alphabet has been used in the array
     */ // TODO
    public static boolean isPangramic(String[] array) {
        char[] alphabet = {'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o', 'p',
                            'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z'};

        HashMap<Character, Boolean> pangramic = new HashMap<Character, Boolean>();
        for(char letter : alphabet) {
            pangramic.put(letter, false);
        }

        for(int i = 0; i < array.length; i++) {
            String word = array[i].toLowerCase();

            for(int j = 0; j < word.length(); j++) {
                char letter = word.charAt(j);
                if(pangramic.containsKey(letter)) {
                    pangramic.put(letter, true);
                }
            }
        }

        boolean results = pangramic.containsValue(false) ? false : true;

        return results;
    }

    /**
     * @param array array of String objects
     * @param value value to check array for
     * @return number of occurrences the specified `value` has occurred
     */ // TODO
    public static int getNumberOfOccurrences(String[] array, String value) {
        int counter = 0;
        for(String word : array) {
            if(word.equals(value)) {
                counter++;
            }
        }
        return counter;
    }

    /**
     * @param array         array of String objects
     * @param valueToRemove value to remove from array
     * @return array with identical contents excluding values of `value`
     */ // TODO
    public static String[] removeValue(String[] array, String valueToRemove) {
        ArrayList<String> arrayList = new ArrayList<String>();

        for(String word : array) {
            arrayList.add(word);
        }

        if(arrayList.contains(valueToRemove)) {
            arrayList.remove(valueToRemove);
        }

        String[] updatedArray = new String[arrayList.size()];
        arrayList.toArray(updatedArray);

        return updatedArray;
    }

    /**
     * @param array array of chars
     * @return array of Strings with consecutive duplicates removes
     */ // TODO
    public static String[] removeConsecutiveDuplicates(String[] array) {
        ArrayList<String> arrayList = new ArrayList<String>();
        String word = array[0];
        arrayList.add(array[0]);

        for(int i = 1; i < array.length; i++) {
            if(!word.equals(array[i])) {
                arrayList.add(array[i]);
                word = array[i];
            }
        }

        String[] updatedArray = new String[arrayList.size()];
        arrayList.toArray(updatedArray);

        return updatedArray;
    }

    /**
     * @param array array of chars
     * @return array of Strings with each consecutive duplicate occurrence concatenated as a single string in an array of Strings
     */ // TODO
    public static String[] packConsecutiveDuplicates(String[] array) {
        ArrayList<String> arrayList = new ArrayList<String>();

        for(int i = 0; i < array.length ; i++) {
            StringBuilder sb = new StringBuilder();
            sb.append(array[i]);
            while(i < array.length - 1 && array[i].equals(array[i + 1])) {
                sb.append(array[i + 1]);
                i++;
            }
            arrayList.add(sb.toString());
        }

        String[] updatedArray = new String[arrayList.size()];
        arrayList.toArray(updatedArray);
        return updatedArray;
    }
}
